Tweaked a function declaraion.
[rsync/rsync.git] / testsuite / rsync.fns
1 #! /bin/sh
2
3 # Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5 # General-purpose test functions for rsync.
6
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License version
9 # 2 as published by the Free Software Foundation.
10 #
11 # This program is distributed in the hope that it will be useful, but
12 # WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
14 # Lesser General Public License for more details.
15
16 # You should have received a copy of the GNU Lesser General Public
17 # License along with this program; if not, write to the Free Software
18 # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
21 tmpdir="$scratchdir"
22 fromdir="$tmpdir/from"
23 todir="$tmpdir/to"
24 chkdir="$tmpdir/chk"
25
26 # Berkley's nice.
27 PATH="$PATH:/usr/ucb"
28
29 if diff -u "$srcdir/testsuite/rsync.fns" "$srcdir/testsuite/rsync.fns" >/dev/null 2>&1; then
30     diffopt="-u"
31 else
32     diffopt="-c"
33 fi
34
35 HOME="$scratchdir"
36 export HOME
37
38 runtest() {
39     echo $ECHO_N "Test $1: $ECHO_C"
40     if eval "$2"
41     then
42         echo "$ECHO_T   done."
43         return 0
44     else
45         echo "$ECHO_T failed!"
46         return 1
47     fi
48 }
49
50 # Call this if you want to filter out verbose messages (-v or -vv) from
51 # the output of an rsync run (whittling the output down to just the file
52 # messages).  This isn't needed if you use -i without -v.
53 filter_outfile() {
54     sed -e '/^building file list /d' \
55         -e '/^created directory /d' \
56         -e '/^done$/d' \
57         -e '/ --whole-file$/d' \
58         -e '/^total: /d' \
59         -e '/^$/,$d' \
60         <"$outfile" >"$outfile.new"
61     mv "$outfile.new" "$outfile"
62 }
63
64 printmsg() {
65     echo "$1"
66 }
67
68 rsync_ls_lR() {
69     find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls"
70 }
71
72 check_perms() {
73     perms=`"$TOOLDIR/tls" "$1" | sed 's/^[-d]\(.........\).*/\1/'`
74     if test $perms = $2; then
75         return 0
76     fi
77     echo "permissions: $perms on $1"
78     echo "should be:   $2"
79     test_fail "failed test $3"
80 }
81
82 rsync_getgroups() { 
83     "$TOOLDIR/getgroups"
84 }
85
86
87 ####################
88 # Build test directories $todir and $fromdir, with $fromdir full of files.
89
90 hands_setup() {
91     # Clean before creation
92     rm -rf "$fromdir"
93     rm -rf "$todir"
94
95     [ -d "$tmpdir" ] || mkdir "$tmpdir"
96     [ -d "$fromdir" ] || mkdir "$fromdir"
97     [ -d "$todir" ] || mkdir "$todir"
98
99     # On some BSD systems, the umask affects the mode of created
100     # symlinks, even though the mode apparently has no effect on how
101     # the links behave in the future, and it cannot be changed using
102     # chmod!  rsync always sets its umask to 000 so that it can
103     # accurately recreate permissions, but this script is probably run
104     # with a different umask. 
105
106     # This causes a little problem that "ls -l" of the two will not be
107     # the same.  So, we need to set our umask before doing any creations.
108
109     # set up test data
110     touch "$fromdir/empty"
111     mkdir "$fromdir/emptydir"
112
113     # a hundred lines of text or so
114     rsync_ls_lR "$srcdir" > "$fromdir/filelist"
115
116     echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
117     umask 0
118     ln -s nolf "$fromdir/nolf-symlink"
119     umask 022
120
121     cat "$srcdir"/*.c > "$fromdir/text"
122     mkdir "$fromdir/dir"
123     cp "$fromdir/text" "$fromdir/dir"
124     mkdir "$fromdir/dir/subdir"
125     echo some data > "$fromdir/dir/subdir/foobar.baz"
126     mkdir "$fromdir/dir/subdir/subsubdir"
127     if [ -r /etc ]; then
128         ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
129     else
130         ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
131     fi
132     mkdir "$fromdir/dir/subdir/subsubdir2"
133     if [ -r /bin ]; then
134         ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
135     else
136         ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
137     fi
138
139 #      echo testing head:
140 #      ls -lR "$srcdir" | head -10 || echo failed
141 }
142
143
144 ####################
145 # Many machines do not have "mkdir -p", so we have to build up long paths.
146 # How boring.  
147 makepath() {
148     echo "        makepath $1"
149     p="$1"
150     (
151         # Absolut Unix.
152         if echo $p | grep '^/' >/dev/null
153         then
154             cd /
155         fi
156     
157         # This will break if $1 contains a space.
158         for c in `echo $p | tr '/' ' '`
159         do 
160             if [ -d "$c" ] || mkdir "$c" 
161             then
162                 cd "$c" || return $?
163             else
164                 echo "failed to create $c" >&2; return $?
165             fi
166         done
167     )
168 }
169
170
171
172 ###########################
173 # Run a test (in '$1') then compare directories $2 and $3 to see if
174 # there are any difference.  If there are, explain them.
175
176 # So normally basically $1 should be an rsync command, and $2 and $3
177 # the source and destination directories.  This is only good when you
178 # expect to transfer the whole directory exactly as is.  If some files
179 # should be excluded, you might need to use something else.
180
181 checkit() {
182     failed=
183
184     # We can just write everything to stdout/stderr, because the
185     # wrapper hides it unless there is a problem.
186
187     echo "Running: \"$1\""  
188     eval "$1" 
189     status=$?
190     if [ $status != 0 ]; then
191         failed="YES";
192     fi
193
194     echo "-------------"
195     echo "check how the directory listings compare with diff:"
196     echo ""
197     ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
198     ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
199     diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
200
201     echo "-------------"
202     echo "check how the files compare with diff:"
203     echo ""
204     if [ "x$4" != x ]; then
205         echo "  === Skipping (as directed) ==="
206     else
207         diff -r $diffopt "$2" "$3" || failed=YES
208     fi
209
210     echo "-------------"
211     if [ -z "$failed" ] ; then
212         return 0
213     else
214         return 1
215     fi
216 }
217
218
219 build_rsyncd_conf() {
220     # Build an appropriate configuration file
221     conf="$scratchdir/test-rsyncd.conf"
222     echo "building configuration $conf"
223
224     port=2612
225     pidfile="$scratchdir/rsyncd.pid"
226     logfile="$scratchdir/rsyncd.log"
227
228     cat >"$conf" <<EOF
229 # rsyncd configuration file autogenerated by $0
230
231 pid file = $pidfile
232 use chroot = no
233 hosts allow = localhost, 127.0.0.1
234 log file = $logfile
235 exclude = foobar.baz
236 max verbosity = 9
237
238 uid = 0
239 gid = 0
240
241 [test-from]
242         path = $fromdir
243         read only = yes
244
245 [test-to]
246         path = $todir
247         read only = no
248 EOF
249 }
250
251
252 build_symlinks() {
253     mkdir "$fromdir"
254     date >"$fromdir/referent"
255     ln -s referent "$fromdir/relative"
256     ln -s "$fromdir/referent" "$fromdir/absolute"
257     ln -s nonexistent "$fromdir/dangling"
258     ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
259 }
260
261 test_fail() {
262     echo "$@" >&2
263     exit 1
264 }
265
266 test_skipped() {
267     echo "$@" >&2
268     echo "$@" > "$tmpdir/whyskipped"
269     exit 77
270 }
271
272 # It failed, but we expected that.  don't dump out error logs, 
273 # because most users won't want to see them.  But do leave
274 # the working directory around.
275 test_xfail() {
276     echo "$@" >&2
277     exit 78
278 }
279
280 # Determine what shell command will appropriately test for links.
281 ln -s foo "$scratchdir/testlink"
282 for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
283 do
284     for switch in -h -L
285     do
286         if $cmd $switch "$scratchdir/testlink" 2>/dev/null
287         then
288             # how nice
289             TEST_SYMLINK_CMD="$cmd $switch"
290             # i wonder if break 2 is portable?
291             break 2
292         fi
293    done
294 done
295 # ok, now get rid of it
296 rm "$scratchdir/testlink"
297
298
299 if [ "x$TEST_SYMLINK_CMD" = 'x' ]
300 then
301     test_fail "Couldn't determine how to test for symlinks"
302 else
303     echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
304 fi
305         
306
307 # Test whether something is a link, allowing for shell peculiarities
308 is_a_link() {
309     # note the variable contains the first option and therefore is not quoted
310     $TEST_SYMLINK_CMD "$1"
311 }
312
313
314 # We need to set the umask to be reproducible.  Note also that when we
315 # do some daemon tests as root, we will setuid() and therefore the
316 # directory has to be writable by the nobody user in some cases.  The
317 # best thing is probably to explicitly chmod those directories after
318 # creation.
319  
320 umask 022